/******************************************************************************
Copyright (C) 2011-2012 Linagora

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU Affero General Public License as published by the Free
Software Foundation, either version 3 of the License, or (at your option) any
later version, provided you comply with the Additional Terms applicable for OBM
connector by Linagora pursuant to Section 7 of the GNU Affero General Public
License, subsections (b), (c), and (e), pursuant to which you must notably (i)
retain the “Message sent thanks to OBM, Free Communication by Linagora”
signature notice appended to any and all outbound messages (notably e-mail and
meeting requests), (ii) retain all hypertext links between OBM and obm.org, as
well as between Linagora and linagora.com, and (iii) refrain from infringing
Linagora intellectual property rights over its trademarks and commercial
brands. Other Additional Terms apply, see <http://www.linagora.com/licenses/>
for more details.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License and
its applicable Additional Terms for OBM along with this program. If not, see
<http://www.gnu.org/licenses/> for the GNU Affero General   Public License
version 3 and <http://www.linagora.com/licenses/> for the Additional Terms
applicable to OBM connectors.
******************************************************************************/
var { ObmLogger } = ChromeUtils.import('chrome://obm-extension/content/components/logger/logger.js')
    // unixFileWriter
var { obmRAddressBookProxy } = ChromeUtils.import('chrome://obm-extension/content/components/obm-sync-rest/obmRAddressBookProxy.js');

Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

function ObmRRemoteAPI() {
    try {
        Components.utils.import("resource://obm-extension/modules/UtilsOBM.jsm");
    } catch (e) {
        Components.utils.reportError(e);
    }
    this.logger = new ObmLogger();

    this.stringBundle = Cc["@mozilla.org/intl/stringbundle;1"].getService(Ci.nsIStringBundleService)
        .createBundle("chrome://obm-extension/locale/errors_warnings.properties");
    this.logger.setLevelWriter(this.logger.LOAD_LEVEL); //, UtilsOBM.getWriter());
    this.logger.setHeader("ObmRRemoteAPIService.js: ");
};

ObmRRemoteAPI.prototype = {
    QueryInterface: ChromeUtils.generateQI([Ci.obmIRRemoteAPI]),
    classID: Components.ID("{f4a5a493-4c2c-4919-97bf-95059e4415ab}"),
    contractID: "@obm.org/obm-sync-rest/service;1",
    classDescription: "OBM RemoteAPI Service",

    /*
     * obmIRRemoteAPI
     */

    createTaskProxy: function() {
        return Cc["@obm.org/obm-sync-rest/taskproxy;1"].createInstance(Ci.obmIRTaskProxy);
    },
    createAddressBookProxy: function() {
        return new obmRAddressBookProxy();
    },
    createCalendarProxy: function() {
        this.logger.debug("createCalendarProxy()", false, false);
        let portUrl = UtilsOBM.getPrefSafe("extensions.obm.server");
        Components.utils.import("chrome://obm-extension/content/components/obm-sync-rest/obmRCalendarProxy.js")
        let calProxy = new ObmRCalendarProxy();
        calProxy.PortUrl = portUrl;
        return calProxy;
    },
    createLoginProxy: function() {
        return Cc["@obm.org/obm-sync-rest/loginproxy;1"].createInstance(Ci.obmIRLoginProxy);
    }
};

// module


var components = [ObmRRemoteAPI];
if ("generateNSGetFactory" in XPCOMUtils) {
    var NSGetFactory = XPCOMUtils.generateNSGetFactory(components);
} else {
    var NSGetModule = XPCOMUtils.generateNSGetModule(components);
}